Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/Utils.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/Utils.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/Utils.java	(revision 44259)
@@ -25,24 +25,40 @@
         return new Comparator() {
             @Override
             public int compare(Object o1, Object o2) {
-                if (o1 instanceof Double) {
-                    return Double.compare((Double) o1, (Double) o2);
-                } else if (o1 instanceof Float) {
-                    return Double.compare((Float) o1, (Float) o2);
-                } else if (o1 instanceof Number) {
-                    return Double.compare( getLong((Number) o1), getLong((Number) o2));
+                if (o1 instanceof Integer && o2 instanceof Number ) {
+                    return Long.compare((Integer) o1, ((Number)o2).intValue());
+                    
+                } else if (o1 instanceof Long && o2 instanceof Number ) {
+                    return Long.compare((Long) o1, ((Number)o2).longValue());
+                    
+                } else if (o1 instanceof Double && o2 instanceof Number ) {
+                    return Double.compare((Double) o1, ((Number)o2).doubleValue());
+                    
+                } else if (o1 instanceof Float && o2 instanceof Number) {
+                    return Double.compare((Float) o1, ((Number)o2).floatValue());
+                    
+                } else if (o1 instanceof Number && o2 instanceof Number) {
+                    return Double.compare( getDouble((Number) o1), getDouble((Number) o2));
+                    
+                } else if (o1 instanceof String && o2 instanceof String) {
+                    return ((String) o1).compareToIgnoreCase((String)o2);
+                    
                 } else {
-                    return Objects.toString(o1, "").compareTo(Objects.toString(o2, ""));
+                    try {
+                        return ((Comparable) o1).compareTo((Comparable)o2);
+                    } catch(Exception ex) {
+                        return Objects.toString(o1, "").compareTo(Objects.toString(o2, ""));
+                    }
                 }
             }
         };
     }
     
-    private static long getLong(Number n) {
+    private static double getDouble(Number n) {
         if( n==null ) {
             return 0;
         }
-        return n.longValue();
+        return n.doubleValue();
     }
 
     public static String repr(Object value)  {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultExpressionBuilderConfig.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultExpressionBuilderConfig.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultExpressionBuilderConfig.java	(revision 44259)
@@ -20,7 +20,7 @@
  * @author jjdelcerro
  */
 public class DefaultExpressionBuilderConfig
-        implements ExpressionBuilderConfig {
+        implements ExpressionBuilderConfig, ExpressionBuilderConfig.Preferences {
 
     private List<Element> elements;
     private int limit;
@@ -29,16 +29,23 @@
     private boolean scriptsEnabled = true;
     private SymbolTable previewSymbolTable;
     private boolean SQLCompatible;
-    private PropertiesSupportHelper propertiesSupportHelper;
+    private final PropertiesSupportHelper propertiesSupportHelper;
+    private boolean showLabelsOfAttributes;
     
     public DefaultExpressionBuilderConfig(ExpressionEvaluatorSwingManager manager) {
         this.manager = manager;
         this.limit = 6;
         this.SQLCompatible = false;
         this.propertiesSupportHelper = new PropertiesSupportHelper();
+        this.showLabelsOfAttributes = true;
         initSymbolTables();
     }
 
+    @Override
+    public Preferences getPreferences() {
+        return this;
+    }
+
     private void initSymbolTables() {
         ExpressionEvaluatorManager theManager = ExpressionEvaluatorLocator.getManager();
         for (SymbolTableFactory factory : theManager.getSymbolTableFactories()) {
@@ -51,11 +58,12 @@
     @Override
     public List<Element> getElements() {
         if (this.elements == null) {
-            this.elements = manager.createElements(this, this.getSymbolTables());
+            this.elements = manager.createElements(this.getSymbolTables());
             for (ElementFactory factory : manager.getElementFactories()) {
                 if (factory.isAutoload()) {
                     Element e = factory.createElement();
                     this.elements.add(e);
+                    e.setConfig(this);
                 }
             }
         }
@@ -74,6 +82,7 @@
             }
         }
         this.elements.add(element);
+        element.setConfig(this);
     }
 
     @Override
@@ -169,5 +178,16 @@
     public Map<String, Object> getProperties() {
         return this.propertiesSupportHelper.getProperties();
     }
+
+    @Override
+    public boolean getShowLabelsOfElements() {
+        return this.showLabelsOfAttributes;
+    }
+
+    @Override
+    public void setShowLabelsOfElements(boolean showLabels) {
+        this.showLabelsOfAttributes = showLabels;
+    }
+
     
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/ExpressionEvaluatorSwingLibraryImpl.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/ExpressionEvaluatorSwingLibraryImpl.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/ExpressionEvaluatorSwingLibraryImpl.java	(revision 44259)
@@ -41,6 +41,8 @@
             new String[] { "action", "expressionbuilder-insert-text" },
             new String[] { "action", "expressionbuilder-sortdown" },
             new String[] { "action", "expressionbuilder-sortup" },
+            new String[] { "action", "expressionbuilder-history" },
+            new String[] { "action", "expressionbuilder-bookmarks" },
             new String[] { "action", "expressionbuilder-time-limit" }
         };
         IconTheme theme = ToolsSwingLocator.getIconThemeManager().getCurrent();
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultJExpressionBuilderView2.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultJExpressionBuilderView2.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultJExpressionBuilderView2.java	(revision 44259)
@@ -0,0 +1,402 @@
+package org.gvsig.expressionevaluator.swing.impl;
+
+import java.awt.BorderLayout;
+import java.awt.Color;
+import java.awt.GridBagConstraints;
+import java.awt.GridBagLayout;
+import java.awt.Insets;
+import javax.swing.ImageIcon;
+import javax.swing.JButton;
+import javax.swing.JComboBox;
+import javax.swing.JLabel;
+import javax.swing.JList;
+import javax.swing.JPanel;
+import javax.swing.JScrollPane;
+import javax.swing.JSplitPane;
+import javax.swing.JTabbedPane;
+import javax.swing.JTextArea;
+import javax.swing.JTextField;
+import javax.swing.JTree;
+import javax.swing.border.EmptyBorder;
+
+public class DefaultJExpressionBuilderView2 extends JPanel {
+
+    private static class GridBagConstraintsBuilder {
+
+        private GridBagConstraints gbc;
+
+        public GridBagConstraintsBuilder() {
+            this.gbc = new GridBagConstraints();
+            this.gbc.insets = new Insets(1, 1, 1, 1);
+        }
+
+        public GridBagConstraintsBuilder clear() {
+            this.gbc = new GridBagConstraints();
+            this.gbc.insets = new Insets(1, 1, 1, 1);
+            return this;
+        }
+
+        public GridBagConstraints get() {
+            return this.gbc;
+        }
+
+        public GridBagConstraintsBuilder insets(int top, int left, int bottom, int right) {
+            this.gbc.insets = new Insets(top, left, bottom, right);
+            return this;
+        }
+
+        public GridBagConstraintsBuilder anchor(int anchor) {
+            this.gbc.anchor = anchor;
+            return this;
+        }
+
+        public GridBagConstraintsBuilder fill(int fill) {
+            this.gbc.fill = fill;
+            return this;
+        }
+
+        public GridBagConstraintsBuilder growx(float growx) {
+            this.gbc.weightx = growx;
+            return this;
+        }
+
+        public GridBagConstraintsBuilder growy(float growy) {
+            this.gbc.weighty = growy;
+            return this;
+        }
+
+        public GridBagConstraintsBuilder grow(float growx, float growy) {
+            this.gbc.weightx = growx;
+            this.gbc.weighty = growy;
+            return this;
+        }
+
+        public GridBagConstraintsBuilder nogrow() {
+            this.gbc.weightx = 0;
+            this.gbc.weighty = 0;
+            return this;
+        }
+
+        public GridBagConstraintsBuilder xy(int x, int y) {
+            this.gbc.gridx = x;
+            this.gbc.gridy = y;
+            return this;
+        }
+
+        private GridBagConstraintsBuilder colspan(int n) {
+            this.gbc.gridwidth = n;
+            return this;
+        }
+
+        private GridBagConstraintsBuilder rowspan(int n) {
+            this.gbc.gridheight = n;
+            return this;
+        }
+
+        private GridBagConstraintsBuilder span(int cols, int rows) {
+            this.gbc.gridwidth = cols;
+            this.gbc.gridheight = rows;
+            return this;
+        }
+
+        private GridBagConstraintsBuilder nospan() {
+            this.gbc.gridwidth = 1;
+            this.gbc.gridheight = 1;
+            return this;
+        }
+
+    }
+
+    JTabbedPane tabExpressionBuilder = new JTabbedPane();
+
+    JList lstSimpleElement = new JList();
+    JScrollPane scrSimpleElement = new JScrollPane();
+
+    JTree treeElements = new JTree();
+    JScrollPane scrElements = new JScrollPane();
+
+    JTextArea txtExpression = new JTextArea();
+    JScrollPane scrExpression = new JScrollPane();
+
+    JButton btnHistory = new JButton();
+    JButton btnBookmarks = new JButton();
+    JButton btnEq = new JButton();
+    JButton btnNeq = new JButton();
+    JButton btnAdd = new JButton();
+    JButton btnSubst = new JButton();
+    JButton btnMult = new JButton();
+    JButton btnDiv = new JButton();
+    JButton btnParentOpen = new JButton();
+    JButton btnParentClose = new JButton();
+    JLabel lblMsg = new JLabel();
+    JButton btnTip = new JButton();
+    JLabel lblColumn = new JLabel();
+    JTextField txtGroupElement = new JTextField();
+    JButton btnGroupElementInsert = new JButton();
+    JButton btnSimpleElementInsert = new JButton();
+    JButton btnSimpleElementSortDown = new JButton();
+    JButton btnSimpleElementSortUp = new JButton();
+    JLabel lblSimpleElementsMsg = new JLabel();
+    JButton btnSimpleElementTimeLimit = new JButton();
+    JTextField txtSimpleElementFilter = new JTextField();
+    JButton btnSimpleElementFilter = new JButton();
+    JPanel pnlDescription = new JPanel();
+    JPanel pnlScriptEditorContainer = new JPanel();
+    JComboBox cboPickerScripts = new JComboBox();
+    JButton btnPickerRemove = new JButton();
+    JButton btnPickerSelectScript = new JButton();
+
+    JSplitPane spnlExpression = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
+    JSplitPane spnlBottom = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
+    JSplitPane spnlItem = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
+
+    JPanel pnlTop;
+    JPanel pnlElement;
+
+    /**
+     * Default constructor
+     */
+    public DefaultJExpressionBuilderView2() {
+        initComponents();
+    }
+
+    private void initComponents() {
+        EmptyBorder emptyborder2x2 = new EmptyBorder(2, 2, 2, 2);
+
+        lstSimpleElement.setName("lstSimpleElement");
+
+        treeElements.setName("treeElements");
+        pnlDescription.setName("pnlDescription");
+        txtExpression.setLineWrap(true);
+        txtExpression.setName("txtExpression");
+        txtExpression.setRows(2);
+
+
+        btnHistory.setActionCommand("+");
+        btnHistory.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/resources/org/gvsig/expressionevaluator/swing/impl/expressionbuilder-history.png"));
+        btnHistory.setName("btnHistory");
+        btnHistory.setText("");
+        btnHistory.setBorder(emptyborder2x2);
+
+        btnBookmarks.setActionCommand("+");
+        btnBookmarks.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/resources/org/gvsig/expressionevaluator/swing/impl/expressionbuilder-bookmarks.png"));
+        btnBookmarks.setName("btnBookmarks");
+        btnBookmarks.setText("");
+        btnBookmarks.setBorder(emptyborder2x2);
+
+        btnEq.setActionCommand("+");
+        btnEq.setName("btnEq");
+        btnEq.setText("=");
+        btnEq.setBorder(emptyborder2x2);
+
+        btnNeq.setActionCommand("+");
+        btnNeq.setName("btnNeq");
+        btnNeq.setText("<>");
+        btnNeq.setBorder(emptyborder2x2);
+
+        btnAdd.setActionCommand("+");
+        btnAdd.setName("btnAdd");
+        btnAdd.setText("+");
+        btnAdd.setBorder(emptyborder2x2);
+
+        btnSubst.setActionCommand("+");
+        btnSubst.setName("btnSubst");
+        btnSubst.setText("-");
+        btnSubst.setBorder(emptyborder2x2);
+
+        btnMult.setActionCommand("+");
+        btnMult.setName("btnMult");
+        btnMult.setText("*");
+        btnMult.setBorder(emptyborder2x2);
+
+        btnDiv.setActionCommand("+");
+        btnDiv.setName("btnDiv");
+        btnDiv.setText("/");
+        btnDiv.setBorder(emptyborder2x2);
+
+        btnParentOpen.setActionCommand("+");
+        btnParentOpen.setName("btnParentOpen");
+        btnParentOpen.setText("(");
+        btnParentOpen.setBorder(emptyborder2x2);
+
+        btnParentClose.setActionCommand("+");
+        btnParentClose.setName("btnParentClose");
+        btnParentClose.setText(")");
+        btnParentClose.setBorder(emptyborder2x2);
+
+        lblMsg.setName("lblMsg");
+
+        btnTip.setActionCommand("+");
+        btnTip.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/resources/org/gvsig/expressionevaluator/swing/impl/expressionbuilder-tip.png.png"));
+        btnTip.setName("btnTip");
+        btnTip.setBorder(emptyborder2x2);
+
+        lblColumn.setName("lblColumn");
+        lblColumn.setText("0");
+
+        txtGroupElement.setBackground(new Color(236, 233, 216));
+        txtGroupElement.setEditable(false);
+        txtGroupElement.setName("txtGroupElement");
+
+        btnGroupElementInsert.setActionCommand("+");
+        btnGroupElementInsert.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/resources/org/gvsig/expressionevaluator/swing/impl/expressionbuilder-insert-text.png"));
+        btnGroupElementInsert.setName("btnGroupElementInsert");
+        btnGroupElementInsert.setBorder(emptyborder2x2);
+
+        btnSimpleElementInsert.setActionCommand("+");
+        btnSimpleElementInsert.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/resources/org/gvsig/expressionevaluator/swing/impl/expressionbuilder-insert-text.png"));
+        btnSimpleElementInsert.setName("btnSimpleElementInsert");
+        btnSimpleElementInsert.setBorder(emptyborder2x2);
+
+        btnSimpleElementSortDown.setActionCommand("+");
+        btnSimpleElementSortDown.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/resources/org/gvsig/expressionevaluator/swing/impl/expressionbuilder-sortdown.png"));
+        btnSimpleElementSortDown.setName("btnSimpleElementSortDown");
+        btnSimpleElementSortDown.setBorder(emptyborder2x2);
+
+        btnSimpleElementSortUp.setActionCommand("+");
+        btnSimpleElementSortUp.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/resources/org/gvsig/expressionevaluator/swing/impl/expressionbuilder-sortup.png"));
+        btnSimpleElementSortUp.setName("btnSimpleElementSortUp");
+        btnSimpleElementSortUp.setBorder(emptyborder2x2);
+
+        lblSimpleElementsMsg.setName("lblSimpleElementsMsg");
+
+        btnSimpleElementTimeLimit.setActionCommand("+");
+        btnSimpleElementTimeLimit.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/resources/org/gvsig/expressionevaluator/swing/impl/expressionbuilder-time-limit.png"));
+        btnSimpleElementTimeLimit.setName("btnSimpleElementTimeLimit");
+        btnSimpleElementTimeLimit.setBorder(emptyborder2x2);
+
+        txtSimpleElementFilter.setName("txtSimpleElementFilter");
+
+        btnSimpleElementFilter.setActionCommand("+");
+        btnSimpleElementFilter.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/resources/org/gvsig/expressionevaluator/swing/impl/expressionbuilder-filter-values.png"));
+        btnSimpleElementFilter.setName("btnSimpleElementFilter");
+        btnSimpleElementFilter.setBorder(emptyborder2x2);
+
+        pnlScriptEditorContainer.setName("pnlScriptEditorContainer");
+
+        cboPickerScripts.setName("cboPickerScripts");
+
+        btnPickerRemove.setActionCommand("+");
+        btnPickerRemove.setName("btnPickerRemove");
+        btnPickerRemove.setText("R");
+        btnPickerRemove.setBorder(emptyborder2x2);
+
+        btnPickerSelectScript.setActionCommand("+");
+        btnPickerSelectScript.setName("btnPickerSelectScript");
+        btnPickerSelectScript.setText("S");
+        btnPickerSelectScript.setBorder(emptyborder2x2);
+
+        this.scrExpression = new JScrollPane();
+        this.scrExpression.setViewportView(txtExpression);
+        this.scrExpression.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
+        this.scrExpression.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
+
+        this.scrElements = new JScrollPane();
+        this.scrElements.setViewportView(treeElements);
+        this.scrElements.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
+        this.scrElements.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
+
+        this.scrSimpleElement = new JScrollPane();
+        this.scrSimpleElement.setViewportView(lstSimpleElement);
+        this.scrSimpleElement.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
+        this.scrSimpleElement.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
+
+        this.spnlExpression.setTopComponent(this.getPanelTop());
+        this.spnlExpression.setBottomComponent(this.spnlBottom);
+        this.spnlExpression.setBorder(emptyborder2x2);
+        this.spnlExpression.setOneTouchExpandable(true);
+
+        this.spnlBottom.setLeftComponent(this.scrElements);
+        this.spnlBottom.setRightComponent(this.spnlItem);
+        this.spnlBottom.setBorder(emptyborder2x2);
+        this.spnlBottom.setOneTouchExpandable(true);
+
+        this.spnlItem.setLeftComponent(this.getPanelElement());
+        this.spnlItem.setRightComponent(this.pnlDescription);
+        this.spnlItem.setBorder(emptyborder2x2);
+        this.spnlItem.setOneTouchExpandable(true);
+
+        this.tabExpressionBuilder.setName("tabExpressionBuilder");
+        this.tabExpressionBuilder.addTab("_Expression", null, this.spnlExpression);
+        this.tabExpressionBuilder.addTab("_Scripts", null, this.pnlScriptEditorContainer);
+        
+        this.setLayout(new BorderLayout());
+        this.add(tabExpressionBuilder, BorderLayout.CENTER);
+
+    }
+
+    private JPanel getPanelTop() {
+        if (this.pnlTop == null) {
+            GridBagConstraintsBuilder cs = new GridBagConstraintsBuilder();
+            cs.anchor(GridBagConstraints.CENTER);
+            cs.fill(GridBagConstraints.BOTH);
+
+            JPanel pnlRight = new JPanel();
+            pnlRight.setLayout(new GridBagLayout());
+            pnlRight.add(this.btnHistory,     cs.xy(0, 0).get());
+            pnlRight.add(this.btnBookmarks,   cs.xy(1, 0).get());
+            pnlRight.add(this.btnEq,          cs.xy(0, 1).get());
+            pnlRight.add(this.btnNeq,         cs.xy(1, 1).get());
+            pnlRight.add(this.btnAdd,         cs.xy(2, 1).get());
+            pnlRight.add(this.btnSubst,       cs.xy(3, 1).get());
+            pnlRight.add(this.btnMult,        cs.xy(0, 2).get());
+            pnlRight.add(this.btnDiv,         cs.xy(1, 2).get());
+            pnlRight.add(this.btnParentOpen,  cs.xy(2, 2).get());
+            pnlRight.add(this.btnParentClose, cs.xy(3, 2).get());
+            pnlRight.add(new JLabel(),        cs.xy(0, 3).span(4,0).grow(1, 1).get());
+
+            JPanel pnlLeft = new JPanel();
+            pnlLeft.setLayout(new GridBagLayout());
+            pnlLeft.add(this.scrExpression, cs.xy(0, 0).span(3, 1).grow(1, 1).get());
+            pnlLeft.add(this.lblMsg, cs.xy(0, 1).nospan().grow(1, 0).get());
+            pnlLeft.add(this.btnTip, cs.xy(1, 1).nospan().nogrow().get());
+            pnlLeft.add(this.lblColumn, cs.xy(2, 1).nospan().nogrow().get());
+
+            JPanel panel = new JPanel();
+            panel.setLayout(new GridBagLayout());
+            panel.add(pnlLeft, cs.xy(0, 0).nospan().grow(1, 1).get());
+            panel.add(pnlRight, cs.xy(1, 0).nospan().nogrow().anchor(GridBagConstraints.NORTH).get());
+
+            this.pnlTop = panel;
+        }
+        return this.pnlTop;
+    }
+
+    private JPanel getPanelElement() {
+        if (this.pnlElement == null) {
+            GridBagConstraintsBuilder cs = new GridBagConstraintsBuilder();
+            cs.anchor(GridBagConstraints.CENTER);
+            cs.fill(GridBagConstraints.BOTH);
+
+            JPanel panel = new JPanel();
+            panel.setLayout(new GridBagLayout());
+            panel.add(this.txtGroupElement, cs.xy(0, 0).span(4, 1).grow(1,0).get());
+            panel.add(this.btnGroupElementInsert, cs.xy(4, 0).nospan().nogrow().get());
+            panel.add(this.txtSimpleElementFilter, cs.xy(0, 1).span(4, 1).grow(1,0).get());
+            panel.add(this.btnSimpleElementInsert, cs.xy(4, 1).nospan().nogrow().get());
+            panel.add(this.scrSimpleElement, cs.xy(0, 2).span(5, 1).grow(1, 1).get());
+            panel.add(new JLabel(), cs.xy(0, 3).nospan().grow(1,0).get());
+            panel.add(this.btnSimpleElementTimeLimit, cs.xy(1, 3).nospan().nogrow().get());
+            panel.add(this.btnSimpleElementSortUp, cs.xy(2, 3).nospan().nogrow().get());
+            panel.add(this.btnSimpleElementSortDown, cs.xy(3, 3).nospan().nogrow().get());
+            panel.add(this.btnSimpleElementInsert, cs.xy(4, 3).nospan().nogrow().get());
+
+            this.pnlElement = panel;
+        }
+        return this.pnlElement;
+    }
+
+    public ImageIcon loadImage(String imageName) {
+        try {
+            ClassLoader classloader = getClass().getClassLoader();
+            java.net.URL url = classloader.getResource(imageName);
+            if (url != null) {
+                ImageIcon icon = new ImageIcon(url);
+                return icon;
+            }
+        } catch (Exception e) {
+            e.printStackTrace();
+        }
+        throw new IllegalArgumentException("Unable to load image: " + imageName);
+    }
+}
